# Licensed Materials - Property of IBM
#
# COPYRIGHT International Business Machines Corp. 2015, 2017
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

import testtools

import pvmcli.util.util as u


class UtilFuncTest(testtools.TestCase):
    ''' Test framework for pvmcli.util.util functions. '''
    def test_parse_float_as_pct(self):
        self.assertRaises(TypeError, u.parse_float_as_pct, "")
        self.assertRaises(TypeError, u.parse_float_as_pct, "abcd")
        self.assertRaises(TypeError, u.parse_float_as_pct, ".12ab")
        self.assertRaises(TypeError, u.parse_float_as_pct, ".12ab%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "12ab%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "ab12%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "ab12.12%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "ab12.12ab%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "ab12.12ab")
        self.assertRaises(TypeError, u.parse_float_as_pct, "1.%")
        self.assertRaises(TypeError, u.parse_float_as_pct, ".%")
        self.assertRaises(TypeError, u.parse_float_as_pct, "%")
        self.assertRaises(TypeError, u.parse_float_as_pct, ".")

        self.assertEqual(1, u.parse_float_as_pct("100"))
        self.assertEqual(1, u.parse_float_as_pct("100.00"))
        self.assertEqual(1, u.parse_float_as_pct("100%"))
        self.assertEqual(1, u.parse_float_as_pct("100.0000%"))

        self.assertEqual(0, u.parse_float_as_pct("0"))
        self.assertEqual(0, u.parse_float_as_pct("0.00"))
        self.assertEqual(0, u.parse_float_as_pct("0%"))
        self.assertEqual(0, u.parse_float_as_pct("0.0000%"))

        self.assertEqual(0.1234, u.parse_float_as_pct("012.340"))
        self.assertEqual(0.1234, u.parse_float_as_pct("12.34"))
        self.assertEqual(0.1234, u.parse_float_as_pct("12.34%"))
        self.assertEqual(0.1234, u.parse_float_as_pct("12.3400%"))
